#ifndef CADASTRAR_CLIENTE_H_INCLUDED
#define CADASTRAR_CLIENTE_H_INCLUDED
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "estruturas.h"

//INSERE CLIENTE NA LISTA ENCADEADA (RETORNA O PONTEIRO HEAD DOS CLIENTES)
struct clientes* insert_cliente2 (struct clientes**,struct clientes*,char*,char*,int,int,int,float,char*,char*,char*,float,int,int*,int,int,int,int,int,int,int);


//VERIFICA SE CLIENTES JA EXISTE
int buscar_cliente(struct clientes*,char*);

//DESPESAS INFERIOR A 40 % DA RENDA MESNSAL
int verificar_credito (int,int);

//CLIENTE COM IDADE MAIOR QUE 18
int verificar_idade (struct datas,int,int,int);

//RENDA MENSAL MAIOR QUE 1,2 SALARIOS MINIMOS
int verificar_renda_mensal (int,int);

//GERA 10 DIGITOS PARA O NUMERO DE CARTAO DE CREDITO
void gerar_nuemro_cartao(int*);

//LE NO ARQUIVO DE ENTRADA AS INFORMARES DO CLIENTE, SE PASSAR NO "TESTE" PARA CADASTRO
//ENTAO  INSERIDO NA LISTA ENCADEADA
struct clientes* cadastrar_cliente(FILE*,FILE*,struct clientes*,struct pcf*,struct datas);

//ABRE O ARQUIVO COM O NOME DO CPF DO CLIENTE (FATURA DO CLIENTE)
void arquivo_cliente2(struct clientes *);

#endif // CADASTRAR_CLIENTE_H_INCLUDED
