#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Compra.h"

void realizar_compra(struct clientes **CLIENTE, int LIMITE, int NUM_PARCELAS, float VALOR_PARCELA)
{
   struct pagar *valor_pagar, *valor_auxiliar;
   int i;

    valor_auxiliar = CLIENTE[0]->pagar_meses;

    for (i=0; i<NUM_PARCELAS; i++)
    {
        valor_pagar = (struct pagar*) calloc (1, sizeof (struct pagar));
        valor_pagar->mes_atual = VALOR_PARCELA;
        valor_pagar->next = NULL;
        if (CLIENTE[0]->pagar_meses == NULL)
        {
           CLIENTE[0]->pagar_meses = valor_pagar;
        }
        else
        {
            CLIENTE[0]->pagar_meses->mes_atual += VALOR_PARCELA;
        }
        CLIENTE[0]->pagar_meses = CLIENTE[0]->pagar_meses->next;
    }
    CLIENTE[0]->pagar_meses = valor_auxiliar;

    valor_auxiliar = CLIENTE[0]->pagar_meses;

    while (valor_auxiliar != NULL)
    {
        valor_auxiliar = valor_auxiliar->next;
    }
}

int busca_de_clientes(char *CPF, struct clientes **head_clientes, int NUM_PARCELAS, float VALOR_PARCELA)
{
    struct clientes *HEAD;
    struct pagar *auxiliar;
    int cont=0, LIMITE, i;

    HEAD = *head_clientes;
    auxiliar = HEAD->pagar_meses;

    while (HEAD != NULL)
    {
        if (strcmp (HEAD->cpf, CPF) == 0)
        {
            LIMITE = head_clientes[0]->limite_credito;
            for (i=0; i<NUM_PARCELAS && auxiliar != NULL; i++)
            {
                if ((auxiliar->mes_atual + VALOR_PARCELA) < LIMITE) cont++;
                auxiliar = auxiliar->next;
            }
            if (cont == i || auxiliar == NULL)
            {
                realizar_compra(head_clientes, LIMITE, NUM_PARCELAS, VALOR_PARCELA);
            }
            else return 5;
            HEAD = HEAD->next;
        }
        else HEAD = HEAD->next;
    }
    return 3;
}

int busca_de_lojas (struct lojas* lojas_head, char *CNPJ)
{
    struct lojas* HEAD;
    HEAD = lojas_head;
    while (HEAD != NULL)
    {
        if (strcmp (HEAD->cnpj, CNPJ) == 0)
        {
            return -1;
        }
        else HEAD = HEAD->next;
    }
    return 1;
}


void adm_compra (struct clientes **head_clientes, struct lojas **head_lojas, FILE *file_entrada, FILE *file_saida)
{
    int num_parcelas, num,num2, n;
    float valor_parcelas;
    char CPF[13], CNPJ[50];

    fgets (CPF, 13, file_entrada);
    CPF[11] = '\0';


    fgets (CNPJ, 50, file_entrada);
    n = strlen (CNPJ);
    CNPJ[n-1] = '\0';


    fscanf (file_entrada, "%d\n", &num_parcelas);
    fscanf (file_entrada, "%f\n", &valor_parcelas);


    num2 = busca_de_lojas (*head_lojas, CNPJ);
    num = busca_de_clientes (CPF, head_clientes, num_parcelas, valor_parcelas);

    if (num2 == 1)
    {
        fprintf (file_saida, "\nCompra nao realizada.\nERRO***Loja nao existente\n");
    }
    else if (num == 3)
    {
         fprintf  (file_saida, "\nCompra nao realizado.\nERRO***Cliente nao Existente\n");
    }
    else if (num == 5)
    {
        fprintf (file_saida, "\nCompra nao realizada.\nERRO***Limite de credito inferior ao esperado\n");
    }

}

