#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "LE_clientes.h"


void arquivo_cliente (struct clientes *cliente)
{
    FILE *file_cliente;
    char CPF[16];
    int i;

    for (i=0; i<11; i++) CPF[i] = cliente->cpf[i];

    file_cliente = fopen (strcat (CPF, ".txt"), "a+");
    fclose (file_cliente);
}


struct clientes* insert_cliente (struct clientes** lista,struct clientes*elem, char* NOME, char* CPF, int nas_dia, int nas_mes, int nas_ano, float renda_mens, char* enderec, char* fone, char* eml, float despsas, int pagmnto, char *numero_cartao, int ade_dia, int ade_mes, int ade_ano, int ven_dia, int ven_mes, int ven_ano)
{
    struct clientes* cur;
    int i;

    for (i=0; NOME[i] != '\n'; i++) elem->nome[i] = NOME[i];
    elem->nome[i] = '\0';
    for (i=0; CPF[i] != '\n'; i++) elem->cpf[i] = CPF[i];
    elem->cpf[i] = '\0';
    for (i=0; enderec[i] != '\n'; i++) elem->endereco[i] = enderec[i];
    elem->endereco[i] = '\0';
    for (i=0; fone[i] != '\n'; i++) elem->telefone[i] = fone[i];
    elem->telefone[i] = '\0';
    for (i=0; eml[i] != '\n'; i++) elem->email[i] = eml[i];
    elem->email[i] = '\0';
    for (i=0; numero_cartao[i] != '\n'; i++) elem->num_cartao[i] = numero_cartao[i];
    i=0;
    elem->nascimento.dia = nas_dia;
    elem->nascimento.mes = nas_mes;
    elem->nascimento.ano = nas_ano;
    elem->renda_mensal = renda_mens;
    elem->despesas = despsas;
    elem->dia_pagamento = pagmnto;
    elem->adesao.dia = ade_dia;
    elem->adesao.mes = ade_mes;
    elem->adesao.ano = ade_ano;
    elem->vencimento.dia = ven_dia;
    elem->vencimento.mes = ven_mes;
    elem->vencimento.ano = ven_ano;
    elem->limite_credito = (6* (elem->renda_mensal - elem->despesas))/10;


    arquivo_cliente(elem);

    elem->next = NULL;
    if (*lista==NULL)
    {
        *lista = elem;
        return *lista;
    }
    cur=*lista;
        while (cur->next!=NULL)
        {
            cur=cur->next;
            i++;
        }
        cur->next=elem;
    return *lista;
}

struct clientes* encadear_clientes(FILE *file_clientes,struct clientes*head_clientes)
{
    char NOME[100], CPF[12], endereco[200], telefone[20], email[100], numero_cartao[11];
    int nas_dia, nas_mes, nas_ano, pagamento, ade_dia, ade_mes, ade_ano, ven_dia, ven_mes, ven_ano;
    float renda_mensal, despesas;
    struct clientes *cliente_encadear=NULL;


    fseek(file_clientes, 0, SEEK_SET);
    if (fscanf (file_clientes, "%s", NOME) ==  EOF)
    {
        return head_clientes;
    }
    fseek(file_clientes, 0, SEEK_SET);

        fgets(NOME, 100, file_clientes);

        fgets(CPF, 13, file_clientes);

        fscanf (file_clientes, "%d/%d/%d\n", &nas_dia, &nas_mes, &nas_ano);

        fscanf (file_clientes, "%f\n", &renda_mensal);

        fgets (endereco, 200, file_clientes);

        fgets (telefone, 20, file_clientes);

        fgets (email, 100, file_clientes);

        fscanf (file_clientes, "%f\n", &despesas);

        fscanf (file_clientes, "%d\n", &pagamento);

        fgets (numero_cartao, 11, file_clientes);

        fscanf (file_clientes, "%d/%d/%d\n", &ade_dia, &ade_mes, &ade_ano);

        fscanf (file_clientes, "%d/%d/%d\n", &ven_dia, &ven_mes, &ven_ano);


        cliente_encadear = (struct clientes*) calloc (1, sizeof (struct clientes));

        head_clientes = insert_cliente(&head_clientes, cliente_encadear, NOME, CPF, nas_dia, nas_mes, nas_ano, renda_mensal, endereco, telefone, email, despesas, pagamento, numero_cartao, ade_dia, ade_mes, ade_ano, ven_dia, ven_mes, ven_ano);

    while (getc (file_clientes) != EOF)
    {
        fseek (file_clientes, -1, SEEK_CUR);

        fgets(NOME, 100, file_clientes);

        fgets(CPF, 13, file_clientes);

        fscanf (file_clientes, "%d/%d/%d\n", &nas_dia, &nas_mes, &nas_ano);

        fscanf (file_clientes, "%f\n", &renda_mensal);

        fgets (endereco, 200, file_clientes);

        fgets (telefone, 20, file_clientes);

        fgets (email, 100, file_clientes);

        fscanf (file_clientes, "%f\n", &despesas);

        fscanf (file_clientes, "%d\n", &pagamento);

        fgets (numero_cartao, 11, file_clientes);

        fscanf (file_clientes, "%d/%d/%d\n", &ade_dia, &ade_mes, &ade_ano);

        fscanf (file_clientes, "%d/%d/%d\n", &ven_dia, &ven_mes, &ven_ano);

        cliente_encadear = (struct clientes*) calloc (1, sizeof (struct clientes));

        head_clientes = insert_cliente (&head_clientes, cliente_encadear, NOME, CPF, nas_dia, nas_mes, nas_ano, renda_mensal, endereco, telefone, email, despesas, pagamento, numero_cartao, ade_dia, ade_mes, ade_ano, ven_dia, ven_mes, ven_ano);

    }

    return head_clientes;
}
