#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Cadastrar_Loja.h"

int buscar_loja (struct lojas *head_lojas, char CNPJ[50])
{
    int n;
    struct lojas *HEAD;
    HEAD = head_lojas;
    while (HEAD != NULL)
    {
        n = strcmp (HEAD->cnpj, CNPJ);
        if (n == 0)
        {
            return 1;
        }
        else HEAD = HEAD->next;
    }
    return 2;
}

void insert_lojas2(struct lojas **lista, char *NOME, char *CNPJ)
{
    struct lojas *cur;
    struct lojas *elem;
    int i;

    elem = (struct lojas*) calloc(1, sizeof(struct lojas));

    for (i=0; NOME[i] != '\0'; i++) elem->nome[i] = NOME[i];
    elem->nome[i] = '\0';
    for (i=0; CNPJ[i] != '\0'; i++) elem->cnpj[i] = CNPJ[i];
    elem->cnpj[i] = '\0';

    elem->next = NULL;

    if (*lista==NULL)
    {
        *lista=elem;
    }
    else
    {
        cur=*lista;
        while (cur->next!=NULL)
        {
            cur=cur->next;
        }
        cur->next=elem;
    }
}

void cadastrar_loja(FILE *file_entrada, FILE *file_saida, struct lojas **lojas_head)
{
    char NOME[50], CNPJ[50];
    int n, num;

    fgets(NOME, 50, file_entrada);
    n = strlen (NOME);
    NOME[n-1] = '\0';
    fgets(CNPJ, 50, file_entrada);
    n = strlen (CNPJ);
    CNPJ[n-1] = '\0';

    num = buscar_loja (*lojas_head, CNPJ);

    if (num == 1) fprintf (file_saida, "\nCadastro de loja nao realizado\nERRO**Loja Ja existente**\n");
    else
    {
        insert_lojas2 (lojas_head, NOME, CNPJ);

        fprintf (file_saida, "\nCadastro de Loja Efetuado com Sucesso\n");

    }
}

