#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "Cadastrar_cliente.h"

void arquivo_cliente2(struct clientes *cliente)
{
    FILE *file_cliente;
    char CPF[13];
    int i;
    do
    {
        i=0;
        CPF[i] = cliente->cpf[i];
        i++;
    }while (CPF[i] != '\0');

    file_cliente = fopen (strcat (CPF, ".txt"), "w");
    fclose (file_cliente);
}

struct clientes* insert_cliente2 (struct clientes **lista, struct clientes *elem, char *NOME, char *CPF, int nas_dia, int nas_mes,
int nas_ano, float renda_mens, char *enderec, char *fone, char *eml, float despsas, int pagmnto, int *numero_cartao,
int ade_dia, int ade_mes, int ade_ano, int ven_dia, int ven_mes, int ven_ano, int limite)
{
    struct clientes *cur;
    int i;

    for (i=0; NOME[i] != '\n'; i++) elem->nome[i] = NOME[i];
    elem->nome[i] = '\0';
    for (i=0; CPF[i] != '\n'; i++) elem->cpf[i] = CPF[i];
    elem->cpf[i] = '\0';
    for (i=0; enderec[i] != '\n'; i++) elem->endereco[i] = enderec[i];
    elem->endereco[i] = '\0';
    for (i=0; fone[i] != '\n'; i++) elem->telefone[i] = fone[i];
    elem->telefone[i] = '\0';
    for (i=0; eml[i] != '\n'; i++) elem->email[i] = eml[i];


    sprintf  (elem->num_cartao, "%d%d%d%d%d%d%d%d%d%d", numero_cartao[0], numero_cartao[1], numero_cartao[2], numero_cartao[3], numero_cartao[4], numero_cartao[5], numero_cartao[6], numero_cartao[7], numero_cartao[8], numero_cartao[9]);

    elem->email[i] = '\0';
    elem->nascimento.dia = nas_dia;
    elem->nascimento.mes = nas_mes;
    elem->nascimento.ano = nas_ano;
    elem->renda_mensal = renda_mens;
    elem->despesas = despsas;
    elem->dia_pagamento = pagmnto;
    elem->adesao.dia = ade_dia;
    elem->adesao.mes = ade_mes;
    elem->adesao.ano = ade_ano;
    elem->vencimento.dia = ven_dia;
    elem->vencimento.mes = ven_mes;
    elem->vencimento.ano = ven_ano;
    elem->limite_credito = limite;


    arquivo_cliente2 (elem);

    elem->next = NULL;
    if (*lista==NULL)
    {
        *lista = elem;
    }
    else
    {
        cur=*lista;
        while (cur->next!=NULL)
        {
            cur=cur->next;
        }
        cur->next=elem;
    }
    return *lista;
}

int buscar_cliente(struct clientes *head_clientes, char CPF[13])
{
    int n;
    struct clientes *HEAD;
    HEAD = head_clientes;
    while (head_clientes != NULL)
    {
        n = strcmp (head_clientes->cpf, CPF);
        if (n == 0)
        {
            head_clientes = HEAD;
            return 1;
        }
        else head_clientes = head_clientes->next;
    }
    head_clientes = HEAD;
    return 2;
}
int buscar_cliente_pcf (struct pcf *head_pcf, char CPF[13])
{
    int n;
    struct pcf *HEAD;
    HEAD = head_pcf;
    while (head_pcf != NULL)
    {
        n = strcmp (head_pcf->cpf_pcf, CPF);
        if (n == 0)
        {
            head_pcf = HEAD;
            return 9;
        }
        else head_pcf = head_pcf->next;
    }
    head_pcf = HEAD;
    return 2;
}
int verificar_credito (int despesas, int renda)
{
    if (despesas > ((4*renda)/10)) return 3;
    else return 2;
}

int verificar_idade (struct datas data_atual, int dia, int mes, int ano)
{
    if ((data_atual.ano - ano) < 18) return 5;
    else
    {
        if ((data_atual.ano - ano ) > 18) return 2;

        else if ((data_atual.ano - ano) == 18)
        {
            if (data_atual.mes < mes) return 5;
            else
            {
                if (data_atual.mes > mes ) return 2;
                else if (data_atual.mes == mes)
                {
                    if (data_atual.dia <= dia) return 5;
                    else return 2;
                }
            }
        }
    }
    return 0;
}

int verificar_renda_mensal (int renda, int salario_minimo)
{
    if (renda < ((12*salario_minimo)/10)) return 7;
    else return 2;
}

void gerar_numero_cartao(int *num)
{
    int n, m;
    int i;
    num[9] = 11;

    do{
        srand((unsigned) time(NULL));
        n = rand();
        m = n%10;
        num[0] = m;
    }while (num[0] == 0);
    for (i=1; i<10; i++ )
    {
        if (i == 1) num[i] = (num[i-1] + 375*461)%10;
        else if (i==5) num[i] = (num[i-2] + num[i-1]* 974)%10;
        else if (i==9) num[i] = (num[i-4] + 4567)%10;
        else num[i] = (num[i-2] + 54*321)%10;
    }
}

struct clientes* cadastrar_cliente(FILE *file_entrada, FILE *file_saida, struct clientes *head_clientes,struct pcf *head_pcf,struct datas data_atual)
{
    char NOME[100], CPF[12], endereco[200], telefone[20], email[100];
    int nas_dia, nas_mes, nas_ano, pagamento, ade_dia, ade_mes, ade_ano, ven_dia, ven_mes, ven_ano;
    float renda_mnsal, dspesas;
    struct clientes *cliente_encadear=NULL;
    int num, numero_cartao[10], limite;

    fgets(NOME, 100, file_entrada);
    fgets(CPF, 13, file_entrada);
    CPF[11] = '\0';
    fscanf (file_entrada, "%d/%d/%d\n", &nas_dia, &nas_mes, &nas_ano);
    fscanf (file_entrada, "%f\n", &renda_mnsal);
    fgets (endereco, 200, file_entrada);
    fgets (telefone, 20, file_entrada);
    fgets (email, 100, file_entrada);
    fscanf (file_entrada, "%f\n", &dspesas);
    fscanf (file_entrada, "%d\n", &pagamento);

    ade_dia =  ven_dia = data_atual.dia;
    ade_mes = ven_mes = data_atual.mes;
    ade_ano = data_atual.ano;
    ven_ano = data_atual.ano + 2;


    limite = (6* (renda_mnsal - dspesas))/10;


    num = buscar_cliente_pcf(head_pcf, CPF);
    if (num==9)
    {
        fputs ("\nCadastro nao realizado\nERRO***Cliente esta no PCF*\n", file_saida);
        return head_clientes;
    }


    num = buscar_cliente (head_clientes, CPF);
    if (num == 1)
    {
        fputs ("\nCadastro nao realizado\nERRO***Cliente ja Existente*\n", file_saida);
        return head_clientes;
    }


    num = verificar_credito (dspesas, renda_mnsal);
    if (num == 3)
    {
        fputs ("\nCadastro nao realizado\nERRO***Despesas fixas em banco altas demais*\n", file_saida);
        return head_clientes;
    }


    num = verificar_idade (data_atual, nas_dia, nas_mes, nas_ano);
    if (num == 5)
    {
        fputs ("\nCadastro de Cliente nao realizado\nERRO***Individuo com idade menor de 18*\n", file_saida);
        return head_clientes;
    }


    num = verificar_renda_mensal (renda_mnsal, 415);
    if (num == 7)
    {
        fputs ("\nCadastro de Cliente nao realizado\nERRO***Renda mensal baixa.\n", file_saida);
        return head_clientes;
    }


    gerar_numero_cartao (numero_cartao);

    if (num == 2)
    {
        cliente_encadear = (struct clientes*) calloc (1, sizeof (struct clientes));
        head_clientes = insert_cliente2 (&head_clientes, cliente_encadear, NOME, CPF, nas_dia, nas_mes,
        nas_ano, renda_mnsal, endereco, telefone, email, dspesas, pagamento, numero_cartao, ade_dia, ade_mes,
        ade_ano, ven_dia, ven_mes, ven_ano, limite);
        fputs ("\nCadastro de Cliente feito com sucesso.\n", file_saida);
    }

    return head_clientes;
}
