#ifndef COMPRA_H_INCLUDED
#define COMPRA_H_INCLUDED
#include "estruturas.h"

//ORGANIZA OS DADOS NECESSARIOS PARA A OPERACAO COMPRA (NUMERO DE PARCELAS E VALOR DE CADA PARCELA)
void adm_compra (struct clientes **head_clientes, struct lojas **head_lojas, FILE *file_entrada, FILE *file_saida);

//VERIFICA SE LOJA EXISTE
int busca_de_lojas (struct lojas* lojas_head, char *CNPJ);

//VERIFICA SE CLIENTE EXISTE, E VERIFICA SE COMPRA PODE SER FEITA(VALOR DE CADA PARCELA MENOR QUE O LIMITE DO CLIENTE)
int busca_de_clientes(char *CPF, struct clientes **head_clientes, int NUM_PARCELAS, float VALOR_PARCELA);

//REALIZA DE FATO A COMPRA: INSERE NA LISTA ENCADEADA DE VALOR A PAGAR DO CLIENTE O VALOR DA PARCELA DA COMPRA
void realizar_compra(struct clientes **CLIENTE, int LIMITE, int NUM_PARCELAS, float VALOR_PARCELA);

#endif // COMPRA_H_INCLUDED

