#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "LE_clientes.h"


struct lojas* insert_lojas(struct lojas** lista,struct lojas*elem, char* NOME, char* CNPJ)
{
    struct lojas* cur;
    int i;

    for (i=0; NOME[i] != '\n'; i++) elem->nome[i] = NOME[i];
    elem->nome[i] = '\0';
    for (i=0; CNPJ[i] != '\n'; i++) elem->cnpj[i] = CNPJ[i];
    elem->cnpj[i] = '\0';

    elem->next = NULL;
    if (*lista==NULL)
    {
        *lista = elem;
        return *lista;
    }
    cur=*lista;
        while (cur->next!=NULL)
        {
            cur=cur->next;
        }
        cur->next=elem;
    return *lista;
}

struct lojas* encadear_lojas(FILE *file_lojas,struct lojas*head_lojas)
{
    char NOME[50], CNPJ[50];
    struct lojas *loja_encadear=NULL;

    fseek(file_lojas, 0, SEEK_SET);
    if (fscanf (file_lojas, "%s", NOME) ==  EOF)
    {
        return head_lojas;
    }

    fseek(file_lojas, 0, SEEK_SET);

        fgets(NOME, 50, file_lojas);

        fgets(CNPJ, 50, file_lojas);


        loja_encadear = (struct lojas*) calloc (1, sizeof (struct lojas));


        head_lojas = insert_lojas(&head_lojas, loja_encadear, NOME, CNPJ);


    while (getc (file_lojas) != EOF)
    {
        fseek (file_lojas, -1, SEEK_CUR);

        fgets(NOME, 50, file_lojas);

        fgets(CNPJ, 50, file_lojas);


        loja_encadear = (struct lojas*) calloc (1, sizeof (struct lojas));

        head_lojas = insert_lojas (&head_lojas, loja_encadear, NOME, CNPJ);
    }

    return head_lojas;
}
