#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "LE_pcf.h"

void insert_pcf (struct pcf **lista, char *CPF)
{
    struct pcf *cur;
    struct pcf *elem;
    int i;

    elem = (struct pcf*) calloc(1, sizeof(struct pcf));

    for (i=0; CPF[i-1] != '\n'; i++) elem->cpf_pcf[i] = CPF[i];
    elem->cpf_pcf[i-1] = '\0';
    elem->next = NULL;

    if (*lista==NULL)
    {
        *lista=elem;
    }
    else
    {
        cur=*lista;
        while (cur->next!=NULL)
        {
            cur=cur->next;

        }
        cur->next=elem;
    }
}
struct pcf* encadear_pcf (FILE* file_pcf,struct pcf* head_pcf)
{
    char CPF[13];

    fseek (file_pcf, 0, SEEK_SET);

    while (!feof(file_pcf))
    {
        fgets(CPF, 50, file_pcf);
        insert_pcf (&head_pcf, CPF);

    }
    return head_pcf;
}
