#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Pagamento.h"

float efetuar_pagamento (struct clientes *cliente, FILE *file_cliente)
{
    float valor;

    valor = cliente->pagar_meses->mes_atual;

    cliente->pagar_meses = cliente->pagar_meses->next;

    return valor;
}

void verificar_data(struct datas *data_atual, struct clientes *head_clientes, FILE *file_saida)
{
    struct clientes *HEAD;
    FILE *file_cliente;
    char CPF[16];
    int i=0;
    float valor;

    HEAD = head_clientes;
    while (HEAD != NULL)
    {
        if (HEAD->dia_pagamento == data_atual->dia && HEAD->pagar_meses != NULL)
        {
            i=0;
            do
            {
                CPF[i] = HEAD->cpf[i];
                i++;
            }
            while (HEAD->cpf[i-1] != '\0');

            file_cliente = fopen (strcat (CPF, ".txt"), "a+");
            fprintf (file_cliente, "\nFATURA MENSAL\n%s\n", data_atual->data_toda);
            valor = efetuar_pagamento(HEAD, file_cliente);
            fprintf (file_saida, "\nEmitir Fatura Mensal: %s %s\n", HEAD->nome, HEAD->cpf);
            fprintf (file_cliente, "Valor Do Mes:%.2f\n\n\n\nEasYCarD\n", valor);
            fprintf (file_cliente, "-------------------------------------------------------------------------------\n");
            fclose (file_cliente);
            HEAD = HEAD->next;
        }
        else HEAD = HEAD->next;
    }
}
