#ifndef ESTRUTURAS_H_INCLUDED
#define ESTRUTURAS_H_INCLUDED

struct datas
{
    int dia;
    int mes;
    int ano;
    char data_toda [11];
};

struct lojas
{
    char nome[50];
    char cnpj[50];
    struct lojas *next;
};

struct pagar
{
    float mes_atual;
    struct pagar *next;
};

struct clientes
{
    char nome[100];
    char cpf[13];
    struct datas nascimento;
    float renda_mensal;
    char endereco[200];
    char telefone[20];
    char email[100];
    float despesas;
    int dia_pagamento;
    int limite_credito;
    char num_cartao[11];
    struct datas adesao;
    struct datas vencimento;
    struct pagar *pagar_meses;
    struct clientes *next;
};

struct pcf
{
    char cpf_pcf[13];
    struct pcf *next;
};



#endif // ESTRUTURAS_H_INCLUDED
